from pyheatpump.db import RowClass
from pyheatpump.db import sql

class VariableType(RowClass):
    slabel: str = None
    label: str = None
    type: str = None
    start_address: int = None
    end_address: int = None
 
    def __init__(self, **kwargs):
        super().__init__(**kwargs)

    @staticmethod
    def getall():
        return dict([
            (row['label'], VariableType(**dict(row)))
            for row in sql('SELECT * FROM var_type') ])
